/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the TemplatesCloneRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TemplatesCloneRequest{}

// TemplatesCloneRequest struct for TemplatesCloneRequest
type TemplatesCloneRequest struct {
	// Ids of templates you want to clone
	TemplateIds []string `json:"template_ids"`
	// Target channel ids to where provided templates should be cloned
	ChannelIds []string `json:"channel_ids"`
	TemplatesByName []TemplateCloneByName `json:"templates_by_name,omitempty"`
	// Templates will get automatically submitted to whatsapp when true
	AutoSubmit *bool `json:"auto_submit,omitempty"`
	// Target organization id where templates will be cloned, required if target is different than source org
	OrganizationId *string `json:"organization_id,omitempty"`
}

// NewTemplatesCloneRequest instantiates a new TemplatesCloneRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTemplatesCloneRequest(templateIds []string, channelIds []string) *TemplatesCloneRequest {
	this := TemplatesCloneRequest{}
	this.TemplateIds = templateIds
	this.ChannelIds = channelIds
	return &this
}

// NewTemplatesCloneRequestWithDefaults instantiates a new TemplatesCloneRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTemplatesCloneRequestWithDefaults() *TemplatesCloneRequest {
	this := TemplatesCloneRequest{}
	return &this
}

// GetTemplateIds returns the TemplateIds field value
func (o *TemplatesCloneRequest) GetTemplateIds() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.TemplateIds
}

// GetTemplateIdsOk returns a tuple with the TemplateIds field value
// and a boolean to check if the value has been set.
func (o *TemplatesCloneRequest) GetTemplateIdsOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.TemplateIds, true
}

// SetTemplateIds sets field value
func (o *TemplatesCloneRequest) SetTemplateIds(v []string) {
	o.TemplateIds = v
}

// GetChannelIds returns the ChannelIds field value
func (o *TemplatesCloneRequest) GetChannelIds() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.ChannelIds
}

// GetChannelIdsOk returns a tuple with the ChannelIds field value
// and a boolean to check if the value has been set.
func (o *TemplatesCloneRequest) GetChannelIdsOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ChannelIds, true
}

// SetChannelIds sets field value
func (o *TemplatesCloneRequest) SetChannelIds(v []string) {
	o.ChannelIds = v
}

// GetTemplatesByName returns the TemplatesByName field value if set, zero value otherwise.
func (o *TemplatesCloneRequest) GetTemplatesByName() []TemplateCloneByName {
	if o == nil || IsNil(o.TemplatesByName) {
		var ret []TemplateCloneByName
		return ret
	}
	return o.TemplatesByName
}

// GetTemplatesByNameOk returns a tuple with the TemplatesByName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplatesCloneRequest) GetTemplatesByNameOk() ([]TemplateCloneByName, bool) {
	if o == nil || IsNil(o.TemplatesByName) {
		return nil, false
	}
	return o.TemplatesByName, true
}

// HasTemplatesByName returns a boolean if a field has been set.
func (o *TemplatesCloneRequest) HasTemplatesByName() bool {
	if o != nil && !IsNil(o.TemplatesByName) {
		return true
	}

	return false
}

// SetTemplatesByName gets a reference to the given []TemplateCloneByName and assigns it to the TemplatesByName field.
func (o *TemplatesCloneRequest) SetTemplatesByName(v []TemplateCloneByName) {
	o.TemplatesByName = v
}

// GetAutoSubmit returns the AutoSubmit field value if set, zero value otherwise.
func (o *TemplatesCloneRequest) GetAutoSubmit() bool {
	if o == nil || IsNil(o.AutoSubmit) {
		var ret bool
		return ret
	}
	return *o.AutoSubmit
}

// GetAutoSubmitOk returns a tuple with the AutoSubmit field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplatesCloneRequest) GetAutoSubmitOk() (*bool, bool) {
	if o == nil || IsNil(o.AutoSubmit) {
		return nil, false
	}
	return o.AutoSubmit, true
}

// HasAutoSubmit returns a boolean if a field has been set.
func (o *TemplatesCloneRequest) HasAutoSubmit() bool {
	if o != nil && !IsNil(o.AutoSubmit) {
		return true
	}

	return false
}

// SetAutoSubmit gets a reference to the given bool and assigns it to the AutoSubmit field.
func (o *TemplatesCloneRequest) SetAutoSubmit(v bool) {
	o.AutoSubmit = &v
}

// GetOrganizationId returns the OrganizationId field value if set, zero value otherwise.
func (o *TemplatesCloneRequest) GetOrganizationId() string {
	if o == nil || IsNil(o.OrganizationId) {
		var ret string
		return ret
	}
	return *o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplatesCloneRequest) GetOrganizationIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrganizationId) {
		return nil, false
	}
	return o.OrganizationId, true
}

// HasOrganizationId returns a boolean if a field has been set.
func (o *TemplatesCloneRequest) HasOrganizationId() bool {
	if o != nil && !IsNil(o.OrganizationId) {
		return true
	}

	return false
}

// SetOrganizationId gets a reference to the given string and assigns it to the OrganizationId field.
func (o *TemplatesCloneRequest) SetOrganizationId(v string) {
	o.OrganizationId = &v
}

func (o TemplatesCloneRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TemplatesCloneRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["template_ids"] = o.TemplateIds
	toSerialize["channel_ids"] = o.ChannelIds
	if !IsNil(o.TemplatesByName) {
		toSerialize["templates_by_name"] = o.TemplatesByName
	}
	if !IsNil(o.AutoSubmit) {
		toSerialize["auto_submit"] = o.AutoSubmit
	}
	if !IsNil(o.OrganizationId) {
		toSerialize["organization_id"] = o.OrganizationId
	}
	return toSerialize, nil
}

type NullableTemplatesCloneRequest struct {
	value *TemplatesCloneRequest
	isSet bool
}

func (v NullableTemplatesCloneRequest) Get() *TemplatesCloneRequest {
	return v.value
}

func (v *NullableTemplatesCloneRequest) Set(val *TemplatesCloneRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableTemplatesCloneRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableTemplatesCloneRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTemplatesCloneRequest(val *TemplatesCloneRequest) *NullableTemplatesCloneRequest {
	return &NullableTemplatesCloneRequest{value: val, isSet: true}
}

func (v NullableTemplatesCloneRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTemplatesCloneRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


